/*	:*****************************************************************
	:	"dta.h" 	:	systemgPridehDTA Cu
	:*****************************************************************
*/
#ifndef	_DTA_H
#define	_DTA_H

#ifndef	_SPDEFS_H
#	include	"spdefs.h"
#endif

#ifdef		FAR
#	undef	FAR
#endif
#define		FAR		_far

#define	DTA_ID_LEN		(12)
extern	CONST	char	DTA_ID[];	/* "PRIDE   .DTA"	*/

#define	DTA_NAME_LEN	(16)
#define	DTA_MAX_CLUSTER	(256)

#define	DTA_STT_NOTHING	(0)
#define	DTA_STT_PARENT	(1)
#define	DTA_STT_CHILD	(2)
#define	DTA_STT_SWAPOUT	(0x80)
#define	DTA_STTBIT_FILE	(0x80)	/* t@CɃXbvAEg	*/

/*	DTA SLOT \	*/
typedef	struct
{	char		name[DTA_NAME_LEN];
	UCHAR		stt;		/* 							*/
	UCHAR		att;		/* 							*/
	USHORT		id;			/* U[u						*/
	size_t		offset;		/* dtaPtr ̃ItZbg		*/
	size_t		size;		/* TCY						*/
	size_t		topCluster;	/* 擪NX^					*/
} DTASLOT_T;

/* DTA ̈wb_[\	*/
typedef	struct
{	char		id[14];
	USHORT		ver;			/* o[W	*/
	size_t		maxSiz;
	size_t		topOfs;
	int			ret;
	USHORT		bytesPerCluster;
	USHORT		clusterMax;		/* R[h		*/
	UCHAR		flagTbl[DTA_MAX_CLUSTER/8];
	int			slotMax;
	DTASLOT_T	slot[1];		/* DTA Xbgi[̈	*/
} DTAHEAD_T;

typedef	struct
{
	size_t	siz;		/* TCY		*/
	int		mode;
	char	rsv[128-8];	/* U[u		*/
	char	path[128];	/* t@C	*/
} DTASWAP_T;

#define	DTA_SWAPMODE_CLEAR	(0x0001)

/*	R[hǗ\	*/
typedef	struct _dta_recode_t
{
	struct _dta_recode_t	*next;
	DTASLOT_T				*dtaSlot;
	int						stt;
	size_t					siz;
	void					*ptr;
	char					p[1];
} DTARECODE_T;

#define	DTA_RECODE_HASH_MAX	(16)

/*	DTA ̈̊Ǘ\	*/
typedef	struct
{
	DTAHEAD_T	*head;
	FAR void	*dtaPtr;
	DTARECODE_T	*recodeHash[DTA_RECODE_HASH_MAX];
	UCHAR		stt;		/* 	*/
	UCHAR		att;		/* 	*/
	SHORT		cd;
} DTACTRL_T;

#define	DTA_BYTES_PER_CLUSTER	(256)	/* NX^̑傫		*/
#define	DTA_HEAD_SIZ			(sizeof(DTAHEAD_T) - sizeof(DTASLOT_T))
#define	DTA_HEAD_AND_SLOT_SIZE(head)	(DTA_HEAD_SIZ + (head)->slotMax * sizeof(DTASLOT_T))

/*	"dta011.c"		------------------------------------------------*/
extern	DTACTRL_T	*DTA_open(void);		/* evZXp	*/

/*	"dta012.c"		------------------------------------------------*/
extern	int			DTA_isAtPcl(void);		/* qvZXp	*/
extern	DTACTRL_T	*DTA_openCheck(void);

/*	"dta013.c"		------------------------------------------------*/
extern	void	DTA_readData( DTACTRL_T *dtaCtrl, void *buf, size_t offset, size_t siz );

/*	"dta014.c"		------------------------------------------------*/
extern	void	DTA_writeData( DTACTRL_T *dtaCtrl, void *buf, size_t offset, size_t siz );

/*	"dta015.c"		------------------------------------------------*/
extern	int		DTA_freeCtrl( DTACTRL_T *dtaCtrl );

/*	"dta016.c"		------------------------------------------------*/
extern	int		DTA_resetCtrl( DTACTRL_T *dtaCtrl );

/*	"dta017.c"		------------------------------------------------*/
extern	int		DTA_dump( CONST char *fn );	/* for DEBUG	*/

/*	"dta018.c"		------------------------------------------------*/
extern	int		DTA_flush( DTACTRL_T *dtaCtrl );

/*	"dta020.c"		------------------------------------------------*/
extern	int		DTA_putHeader( DTACTRL_T *dtaCtrl );

/*	"dta021.c"		------------------------------------------------*/
extern	int		DTA_getHeader( DTACTRL_T *dtaCtrl );

/*	"dta030.c"		------------------------------------------------*/
extern	DTASLOT_T	*DTA_getSlot( DTACTRL_T *dtaCtrl, CONST char *name );

/*	"dta031.c"		------------------------------------------------*/
extern	DTASLOT_T	*DTA_openSlot( DTACTRL_T *dtaCtrl, CONST char *name, size_t siz );

/*	"dta032.c"		------------------------------------------------*/
extern	int		DTA_clearSlot( DTACTRL_T *dtaCtrl, DTASLOT_T *dtaSlot );

/*	"dta033.c"		------------------------------------------------*/
extern	int		DTA_removeSlot( DTACTRL_T *dtaCtrl, CONST char *name );

/*	"dta034.c"		------------------------------------------------*/
extern	size_t	DTA_getFreeCluster( DTACTRL_T *dtaCtrl );

/*==================================================================*/
/*	"dta040.c"		------------------------------------------------*/
extern	DTARECODE_T	*DTA_createRecode( DTACTRL_T *dtaCtrl, CONST char *name, size_t siz );
extern	DTARECODE_T	*DTA_openRecode( DTACTRL_T *dtaCtrl, CONST char *name );
extern	int		DTA_closeRecode( DTACTRL_T *dtaCtrl, DTARECODE_T *dtaRecode );

/*	"dta041.c"		------------------------------------------------*/
extern	int		DTA_flushRecode( DTACTRL_T *dtaCtrl, DTARECODE_T *dtaRecode );

/*	"dta042.c"		------------------------------------------------*/
extern	int		DTA_freeAllRecode( DTACTRL_T *dtaCtrl );

/*	"dta043.c"		------------------------------------------------*/
extern	int		DTA_readRecode( DTACTRL_T *dtaCtrl, DTARECODE_T *dtaRecode );

#endif
